Scriptable (rhino 1.7.15 API)

Package org.mozilla.javascript

## Interface Scriptable

- All Known Subinterfaces:
    `Function`
  All Known Implementing Classes:
    `ArrowFunction`, `BaseFunction`, `BindingsObject`, `BoundFunction`, `Delegator`, `Environment`, `ES6Generator`, `ES6Iterator`, `FunctionObject`, `Global`, `IdFunctionObject`, `IdFunctionObjectES6`, `IdScriptableObject`, `ImporterTopLevel`, `LambdaConstructor`, `LambdaFunction`, `ModuleScope`, `NativeArray`, `NativeArrayBuffer`, `NativeArrayBufferView`, `NativeArrayIterator`, `NativeCall`, `NativeCallSite`, `NativeCollectionIterator`, `NativeConsole`, `NativeContinuation`, `NativeDataView`, `NativeFloat32Array`, `NativeFloat64Array`, `NativeFunction`, `NativeGenerator`, `NativeInt16Array`, `NativeInt32Array`, `NativeInt8Array`, `NativeIterator`, `NativeIterator.StopIteration`, `NativeJavaArray`, `NativeJavaClass`, `NativeJavaConstructor`, `NativeJavaList`, `NativeJavaMap`, `NativeJavaMethod`, `NativeJavaObject`, `NativeJavaPackage`, `NativeJavaTopPackage`, `NativeJSON`, `NativeMap`, `NativeObject`, `NativePromise`, `NativeRegExp`, `NativeSet`, `NativeStringIterator`, `NativeSymbol`, `NativeTypedArrayView`, `NativeUint16Array`, `NativeUint32Array`, `NativeUint8Array`, `NativeUint8ClampedArray`, `NativeWeakMap`, `NativeWeakSet`, `NativeWith`, `Require`, `ScriptableObject`, `Synchronizer`, `TopLevel`, `XMLObject`

      public interface Scriptable

  This is interface that all objects in JavaScript must implement. The interface provides for the management of properties and for performing conversions.

  Host system implementors may find it easier to extend the ScriptableObject class rather than implementing Scriptable when writing host objects.

  There are many static methods defined in ScriptableObject that perform the multiple calls to the Scriptable interface needed in order to manipulate properties in prototype chains.

  See Also:
    `ScriptableObject`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.Object` | `NOT_FOUND` | Value returned from `get` if the property is not found.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `delete​(int index)` | Removes a property from this object.
    `void` | `delete​(java.lang.String name)` | Removes a property from this object.
    `java.lang.Object` | `get​(int index, Scriptable start)` | Get a property from the object selected by an integral index.
    `java.lang.Object` | `get​(java.lang.String name, Scriptable start)` | Get a named property from the object.
    `java.lang.String` | `getClassName()` | Get the name of the set of objects implemented by this Java class.
    `java.lang.Object` | `getDefaultValue​(java.lang.Class<?> hint)` | Get the default value of the object with a given hint.
    `java.lang.Object[]` | `getIds()` | Get an array of property ids.
    `Scriptable` | `getParentScope()` | Get the parent scope of the object.
    `Scriptable` | `getPrototype()` | Get the prototype of the object.
    `boolean` | `has​(int index, Scriptable start)` | Indicates whether or not an indexed property is defined in an object.
    `boolean` | `has​(java.lang.String name, Scriptable start)` | Indicates whether or not a named property is defined in an object.
    `boolean` | `hasInstance​(Scriptable instance)` | The instanceof operator.
    `void` | `put​(int index, Scriptable start, java.lang.Object value)` | Sets an indexed property in this object.
    `void` | `put​(java.lang.String name, Scriptable start, java.lang.Object value)` | Sets a named property in this object.
    `void` | `setParentScope​(Scriptable parent)` | Set the parent scope of the object.
    `void` | `setPrototype​(Scriptable prototype)` | Set the prototype of the object.

- - ### Field Detail

    - #### NOT_FOUND

          static final java.lang.Object NOT_FOUND

      Value returned from `get` if the property is not found.

  - ### Method Detail

    - #### getClassName

          java.lang.String getClassName()

      Get the name of the set of objects implemented by this Java class. This corresponds to the [[Class]] operation in ECMA and is used by Object.prototype.toString() in ECMA.

      See ECMA 8.6.2 and 15.2.4.2.

    - #### get

          java.lang.Object get​(java.lang.String name,
                               Scriptable start)

      Get a named property from the object.

      Looks property up in this object and returns the associated value if found. Returns NOT_FOUND if not found. Note that this method is not expected to traverse the prototype chain. This is different from the ECMA [[Get]] operation.

      Depending on the property selector, the runtime will call this method or the form of `get` that takes an integer:

      JavaScript code | Java code
      --- | ---
      a.b | a.get("b", a)
      a["foo"] | a.get("foo", a)
      a[3] | a.get(3, a)
      a["3"] | a.get(3, a)
      a[3.0] | a.get(3, a)
      a["3.0"] | a.get("3.0", a)
      a[1.1] | a.get("1.1", a)
      a[-4] | a.get(-4, a)

      The values that may be returned are limited to the following:

      - java.lang.Boolean objects
      - java.lang.String objects
      - java.lang.Number objects
      - org.mozilla.javascript.Scriptable objects
      - null
      - The value returned by Context.getUndefinedValue()
      - NOT_FOUND
      Parameters:
        `name` - the name of the property
        `start` - the object in which the lookup began
      Returns:
        the value of the property (may be null), or NOT_FOUND
      See Also:
        `Context.getUndefinedValue()`

    - #### get

          java.lang.Object get​(int index,
                               Scriptable start)

      Get a property from the object selected by an integral index.

      Identical to `get(String, Scriptable)` except that an integral index is used to select the property.

      Parameters:
        `index` - the numeric index for the property
        `start` - the object in which the lookup began
      Returns:
        the value of the property (may be null), or NOT_FOUND
      See Also:
        `get(String,Scriptable)`

    - #### has

          boolean has​(java.lang.String name,
                      Scriptable start)

      Indicates whether or not a named property is defined in an object.

      Does not traverse the prototype chain.

      The property is specified by a String name as defined for the `get` method.

      Parameters:
        `name` - the name of the property
        `start` - the object in which the lookup began
      Returns:
        true if and only if the named property is found in the object
      See Also:
        `get(String, Scriptable)`, `ScriptableObject.getProperty(Scriptable, String)`

    - #### has

          boolean has​(int index,
                      Scriptable start)

      Indicates whether or not an indexed property is defined in an object.

      Does not traverse the prototype chain.

      The property is specified by an integral index as defined for the `get` method.

      Parameters:
        `index` - the numeric index for the property
        `start` - the object in which the lookup began
      Returns:
        true if and only if the indexed property is found in the object
      See Also:
        `get(int, Scriptable)`, `ScriptableObject.getProperty(Scriptable, int)`

    - #### put

          void put​(java.lang.String name,
                   Scriptable start,
                   java.lang.Object value)

      Sets a named property in this object.

      The property is specified by a string name as defined for `get`.

      The possible values that may be passed in are as defined for `get`. A class that implements this method may choose to ignore calls to set certain properties, in which case those properties are effectively read-only.

      For properties defined in a prototype chain, use `putProperty` in ScriptableObject.

      Note that if a property a is defined in the prototype p of an object o, then evaluating `o.a = 23` will cause `set` to be called on the prototype p with o as the start parameter. To preserve JavaScript semantics, it is the Scriptable object's responsibility to modify o.

      This design allows properties to be defined in prototypes and implemented in terms of getters and setters of Java values without consuming slots in each instance.

      The values that may be set are limited to the following:

      - java.lang.Boolean objects
      - java.lang.String objects
      - java.lang.Number objects
      - org.mozilla.javascript.Scriptable objects
      - null
      - The value returned by Context.getUndefinedValue()

      Arbitrary Java objects may be wrapped in a Scriptable by first calling `Context.toObject`. This allows the property of a JavaScript object to contain an arbitrary Java object as a value.

      Note that `has` will be called by the runtime first before `set` is called to determine in which object the property is defined. Note that this method is not expected to traverse the prototype chain, which is different from the ECMA [[Put]] operation.

      Parameters:
        `name` - the name of the property
        `start` - the object whose property is being set
        `value` - value to set the property to
      See Also:
        `has(String, Scriptable)`, `get(String, Scriptable)`, `ScriptableObject.putProperty(Scriptable, String, Object)`, `Context.toObject(Object, Scriptable)`

    - #### put

          void put​(int index,
                   Scriptable start,
                   java.lang.Object value)

      Sets an indexed property in this object.

      The property is specified by an integral index as defined for `get`.

      Identical to `put(String, Scriptable, Object)` except that an integral index is used to select the property.

      Parameters:
        `index` - the numeric index for the property
        `start` - the object whose property is being set
        `value` - value to set the property to
      See Also:
        `has(int, Scriptable)`, `get(int, Scriptable)`, `ScriptableObject.putProperty(Scriptable, int, Object)`, `Context.toObject(Object, Scriptable)`

    - #### delete

          void delete​(java.lang.String name)

      Removes a property from this object. This operation corresponds to the ECMA [[Delete]] except that the no result is returned. The runtime will guarantee that this method is called only if the property exists. After this method is called, the runtime will call Scriptable.has to see if the property has been removed in order to determine the boolean result of the delete operator as defined by ECMA 11.4.1.

      A property can be made permanent by ignoring calls to remove it.

      The property is specified by a String name as defined for `get`.

      To delete properties defined in a prototype chain, see deleteProperty in ScriptableObject.

      Parameters:
        `name` - the identifier for the property
      See Also:
        `get(String, Scriptable)`, `ScriptableObject.deleteProperty(Scriptable, String)`

    - #### delete

          void delete​(int index)

      Removes a property from this object.

      The property is specified by an integral index as defined for `get`.

      To delete properties defined in a prototype chain, see deleteProperty in ScriptableObject.

      Identical to `delete(String)` except that an integral index is used to select the property.

      Parameters:
        `index` - the numeric index for the property
      See Also:
        `get(int, Scriptable)`, `ScriptableObject.deleteProperty(Scriptable, int)`

    - #### getPrototype

          Scriptable getPrototype()

      Get the prototype of the object.
      Returns:
        the prototype

    - #### setPrototype

          void setPrototype​(Scriptable prototype)

      Set the prototype of the object.
      Parameters:
        `prototype` - the prototype to set

    - #### getParentScope

          Scriptable getParentScope()

      Get the parent scope of the object.
      Returns:
        the parent scope

    - #### setParentScope

          void setParentScope​(Scriptable parent)

      Set the parent scope of the object.
      Parameters:
        `parent` - the parent scope to set

    - #### getIds

          java.lang.Object[] getIds()

      Get an array of property ids.

      Not all property ids need be returned. Those properties whose ids are not returned are considered non-enumerable.

      Returns:
        an array of Objects. Each entry in the array is either a java.lang.String or a java.lang.Number

    - #### getDefaultValue

          java.lang.Object getDefaultValue​(java.lang.Class<?> hint)

      Get the default value of the object with a given hint. The hints are String.class for type String, Number.class for type Number, Scriptable.class for type Object, and Boolean.class for type Boolean.

      A `hint` of null means "no hint".

      See ECMA 8.6.2.6.

      Parameters:
        `hint` - the type hint
      Returns:
        the default value

    - #### hasInstance

          boolean hasInstance​(Scriptable instance)

      The instanceof operator.

      The JavaScript code "lhs instanceof rhs" causes rhs.hasInstance(lhs) to be called.

      The return value is implementation dependent so that embedded host objects can return an appropriate value. See the JS 1.3 language documentation for more detail.

      This operator corresponds to the proposed EMCA [[HasInstance]] operator.

      Parameters:
        `instance` - The value that appeared on the LHS of the instanceof operator
      Returns:
        an implementation dependent value